component-section
  div(slot='title') 🔀 Sorteren
  component-section
    div(slot='title') Waarom je over sorteren leert
    p Sorteren/gesorteerdheid ligt aan de basis van de meeste praktische algoritmes.
    p.praktijk
      | Databasesystemen zoals
      |
      a(href='https://www.postgresql.org/docs/13/queries-order.html') PostgreSQL
      |
      | kunnen data van hetzelfde type (bijvoorbeeld een kolom) sorteren, zodat snel zoeken mogelijk is.
    p.praktijk
      | In tegenstelling tot vele andere (standaard)algoritmes, zijn sorteeralgoritmes is niet alleen een bouwsteen voor complexere algoritmes, maar zeker ook rechtstreeks relevant voor functionele vereisten.
      | Denk aan een spreadsheet-app, waarin je wilt kunnen sorteren.
  component-section
    div(slot='title') Binary search
    p
      | Om een rij te kunnen sorteren, is allereerst van belang dat de elementen van de rij
      |
      em vergelijkbaar
      |
      | zijn (een totale ordening hebben).
      | Laten we beginnen met een voorbeeld van het nut van een gesorteerde rij.
    p
      em.term Binary search
      |
      | is een eenvoudig algoritme voor efficiënt
      |
      em zoeken
      |
      | naar een element in een al gesorteerde rij.
      | Binary search heeft in het gemiddelde en slechtste geval een betere looptijd (van \(O(\log(n))\)) dan
      |
      em.term linear search
      |
      | (van \(O(n)\)).
    p
      | Als de rij gesorteerd is kan je daardoor dus het schaalbaardere binary search gebruiken voor zoeken.
    p
      em Binary
      |
      | verwijst overigens naar het opdelen van de rij in telkens twee deelrijen.
    p.bron Binary Search - Algorithm and Pseudo-code
    component-video(videoid='2BhQxgIgXX4', title='Binary Search - Algorithm and Pseudo-code')
    p.bron
      a(href='https://opendsa.cs.vt.edu/ODSA/Books/Everything/html/BinarySearch.html') Searching in an Array
  component-section
    div(slot='title') Insertion sort
    p
      em.term Insertion sort
      |
      | is een eenvoudig sorteeralgoritme, dat lijkt op hoe spelers van kaartspelen vaak hun kaarten in de hand sorteren.
    p.bron Insertion Sort Algorithm
    p OpenDSA bevat een handige visualisatie en de broncode:
    p.bron
      a(href='https://opendsa-server.cs.vt.edu/ODSA/Books/Everything/html/InsertionSort.html') Insertion Sort
    p Rosetta Code bevat veel voorbeeldimplementaties in talloze programmeertalen:
    p.bron
      a(href='https://rosettacode.org/wiki/Sorting_algorithms/Insertion_sort') Sorting algorithms/Insertion sort
    p
      | Insertion sort is nog steeds een eenvoudig algoritme, en heeft ook weer een looptijd in het gemiddelde en slechtste geval van maar liefst \(Θ(n^2)\).
      | Insertion sort heeft wel een goede looptijd van \(Θ(n)\) in het beste geval, omdat deels al gesorteerde deelrijen de benodigde looptijd omlaag brengen. Het beste geval is echter lastig voorspelbaar, dus maakt insertion sort niet veel aantrekkelijker.
  component-section
    div(slot='title') Selection sort
    p
      em.term Selection sort
      |
      | houdt in het telkens zoeken naar het grootste nog ongesorteerde element in de lijst.
      | Dat element wisselt Selection sort telkens om.
      | Dat grootste nog ongesorteerde element wordt omgewisseld met het element vóór het laatste al gesorteerde element.
      | De eerste wisseling moet zijn: wissel het grootste element met het laatste element uit de lijst.
      | De lijst wordt vervolgens van het einde van de lijst richting het begin gesorteerd.
      | Selection sort kan natuurlijk ook geïmplementeerd worden door naar het
      |
      em kleinste
      |
      | element te zoeken en van voren af aan te sorteren.
      | Het algoritme zou daardoor niet wezenlijk anders zijn en heet daarom óók Selection sort.
    p OpenDSA bevat een handige visualisatie en de broncode:
    p.bron
      a(href='https://opendsa-server.cs.vt.edu/ODSA/Books/Everything/html/SelectionSort.html') Selection Sort
    p
      | Selection sort is weliswaar een eenvoudig algoritme, maar heeft in alle gevallen een looptijd van maar liefst \(Θ(n ^ 2)\), vanwege de groei van het aantal
      |
      em vergelijkingen
      | tussen elementen naarmate de lijst langer is.
      | Het aantal vergelijkingen groeit snel doordat voor ieder ander element (en er zijn er \(n - 1\)) het grootste nog ongesorteerde element moet worden gezocht (door het \(n - 1 - \text{aantal}_\text{gesorteerd}\) keer te vergelijken).
      | Dit is uit te drukken als \(\frac{1}{2}n(n-1)=\frac{1}{2}(n ^ 2 - n)\) vergelijkingen, en dat wordt in algoritmeanalyse vereenvoudigd tot een groeiorde van \(n ^ 2\).
      | Het aantal
      |
      em wisselingen
      |
      | kan wel lager uitpakken als de data vooraf al gesorteerd was, maar beide soorten instructies tellen en beschouwen we als even zwaar binnen het machinemodel.
      | De begrenzing is ook \(Θ(\cdot)\), dus strikter dan \(O(\cdot)\), omdat het aantal vergelijkingen niet langzamer of sneller groeit in verhouding tot verschillende mogelijke invoergroottes.
      | Het aantal vergelijkingen groeit evenmin langzamer of sneller in verhouding tot mogelijke inhouden van de lijst (bijvoorbeeld een al gesorteerde versus een ongesorteerde lijst), dus de groeiorde en begrenzing gelden inderdaad
      |
      em in alle gevallen
      | .
  component-section
    div(slot='title') Merge sort
    p
      em.term Merge sort
      |
      | is een sorteeralgoritme met in alle gevallen een looptijd van \(Θ(n \log(n)\), wat beter is dan de eerder vermelde gemiddelde en slechtste gevallen van Insertion en Selection sort.
    p
      | Merge sort is gebaseerd op divide-and-conquer.
      | Je kan Merge sort recursief of iteratief formuleren en implementeren, maar veel basisuitleg gaat uit van een recursieve formulering.
    p Jeff Erickson legt het algoritme en zijn geschiedenis uit:
    p.bron
      a(href='http://jeffe.cs.illinois.edu/teaching/algorithms/book/01-recursion.pdf') Mergesort
      |
      cite(data-id='6867189/PLHZEH2X', data-label='section', data-locator='1.4')
      |
      | (bewijzen behoren niet tot ADP)
    p OpenDSA bevat een handige visualisatie en voorbeeldbroncode:
    p.bron
      a(href='https://opendsa-server.cs.vt.edu/ODSA/Books/Everything/html/Mergesort.html') Mergesort Concepts
    p.bron Merge Sort 1 - The Algorithm
    component-video(videoid='M5kMzPswo20', title='Merge Sort 1 - The Algorithm')
    p.bron Merge Sort: Top-Down and Bottom-Up
    component-video(videoid='k3oezbZgfDs', title='Merge Sort: Top-Down and Bottom-Up')
    p Rosetta Code bevat veel voorbeeldimplementaties in talloze programmeertalen:
    p.bron
      a(href='https://rosettacode.org/wiki/Sorting_algorithms/Merge_sort') Sorting algorithms/Merge sort
    component-section
      div(slot='title') Waarom je Merge sort leert
      p
        | In Java SE 14 wordt een variant van Merge sort als standaardimplementatie van
        |
        code.hljs.lang-java List.sort()
        |
        | gebruikt.
        | Het is dus zeker een standaardalgoritme.
      p.bron
        a(
          href='https://docs.oracle.com/en/java/javase/14/docs/api/java.base/java/util/List.html#sort(java.util.Comparator)')
          code.hljs.lang-java List.sort()
          |
          | API docs.
  component-section
    div(slot='title') Quicksort
    p
      | Quicksort is een algoritme dat in de praktijk vaak gebruikt wordt, omdat het in het gemiddelde geval een goede looptijd heeft van \(O(n \log(n))\).
    p
      | Quicksort kent vele algoritme- en implementatievarianten ervan.
      | Bovendien gebruiken Quicksortimplementaties in de praktijk ook een ander sorteeralgoritme als Insertion sort zodra een deelrij erg klein is, want dan weegt de lage constante overhead van Insertion sort zwaarder dan zijn in het gemiddelde geval slechte complexiteitscategorie.
    p
      | Net als Merge sort is Quicksort gebaseerd op divide-and-conquer.
      | Je kan Quicksort eveneens recursief of iteratief formuleren en implementeren, maar veel basisuitleg gaat uit van een recursieve formulering.
    p Jeff Erickson legt het algoritme en zijn geschiedenis uit:
    p.bron
      a(href='http://jeffe.cs.illinois.edu/teaching/algorithms/book/01-recursion.pdf') Quicksort
      |
      cite(data-id='6867189/PLHZEH2X', data-label='section', data-locator='1.5-1.6')
      |
      | (bewijzen behoren niet tot ADP)
    p OpenDSA bevat een handige visualisatie en voorbeeldbroncode:
    p.bron
      a(href='https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/Quicksort.html') Quicksort
    p.bron Quicksort 1 - The Algorithm
    component-video(videoid='h_9kAXFKJwY', title='Quicksort 1 - The Algorithm')
    p
      | Net als bij Merge sort kan je van Quicksort een goed leesbare recursieve implementatie uitprogrammeren, of een slechter leesbare maar in de praktijk efficiëntere iteratieve.
    p.bron Quicksort 2 - Alternative Algorithm
    component-video(videoid='O5V5JTa3O20', title='Quicksort 2 - Alternative Algorithm')
    p.bron Quick Sort and Quick Select
    p David Taylor gaat wat meer de diepte in, en vergelijkt verschillende varianten:
    component-video(videoid='v-1EGgaTFuw', title='Quick Sort and Quick Select')
    p Rosetta Code bevat veel voorbeeldimplementaties in talloze programmeertalen:
    p.bron
      a(href='https://rosettacode.org/wiki/Sorting_algorithms/Quicksort') Quicksort
    component-section
      div(slot='title') Spil (pivot) en partitioneren
      p
        | Alleen de naam van het algoritme, ‘Quicksort’, zegt vergeleken met de meeste standaardalgoritmes erg weinig.
        | De manier waarop de
        |
        em.term pivot
        |
        | wordt gekozen is cruciaal, maar wordt in allerlei varianten van Quicksort anders ingevuld.
        | Dat met goede reden, want de invoerdata kan bijvoorbeeld verschillen voor toepassen.
        | Van alle manieren zijn er gelukkig maar enkele overgebleven die betrouwbaar bleken.
        | Als het gaat om het aantal spillen:
      ul
        li Enkele
        li Dubbele (
          a(href='https://devdocs.io/openjdk~17/java.base/java/util/arrays#sort(byte%5B%5D)') Java
          | )
      p Ook kan je aan de hand van één spil op verschillende manieren partitioneren:
      ul
        li Met één index die één kant uit beweegt (Lomuto).
        li Met een linker- en rechterindex die naar elkaar toe bewegen (Hoare).
      p De keuze van spil kent veel gangbare varianten:
      ul
        li Willekeurig (random): robuust tegen invoerdata in het slechtste geval (voorgesorteerd, veel herhaling).
        li Het middelste (‘median of three’) item: ook enigszins robuust, en heeft geen willekeurige getallen nodig (kostbaar), maar kan door aanvaller gemanipuleerde invoerdata niet weerstaan (mogelijke denial of service).
        li Het eerste of laatste item: snel afgerond en begrijpelijk, maar niet robuust.
      p Tot slot, hoeveel deelrijen er gemaakt worden aan de hand van de spil:
      ul
        li Twee (standaard)
        li Drie (Dijkstra)
    p In het slechtste geval heeft Quicksort een looptijd van \(O(n^2)\).
    component-section
      div(slot='title') Waarom je Quicksort leert
      p
        | In Java SE 14 wordt een variant van Quicksort als standaardimplementatie van
        |
        code.hljs.lang-java Arrays.sort()
        |
        | gebruikt.
        | Het is dus zeker een standaardalgoritme.
      p.bron
        a(href='https://docs.oracle.com/en/java/javase/14/docs/api/java.base/java/util/Arrays.html#sort(int%5B%5D)')
          code.hljs.lang-java Arrays.sort()
          | API docs
  component-section(extra)
    div(slot='title') Complexiteitscategorie bij vergelijkingsgebaseerd sorteren van lijsten in het algemeen
    p
      | Tot nu toe hebben we het over het sorteren van rijen gehad, niet over lijsten in het algemeen.
      | Insertion sort en Quicksort hebben een slechtere complexiteitscategorie op linked lists dan op rijen, omdat elementen niet in constante looptijd benaderd kunnen worden (zoals met indexeren in een rij wel kan).
      | Een extreme oplossing zou kunnen zijn het omzetten van de linked list naar een rij, sorteren met bijvoorbeeld Quicksort, en de rij weer omzetten naar een linked list.
      | Dat heeft een looptijd van \(O(n) + O(n \log(n)) + O(n)\), wat nog steeds beter is dan \(O(n^2)\).
      | Een eenvoudige oplossing is het besef dat als je een linked list moet gaan sorteren, je misschien niet de beste datastructuur voor je algoritme hebt gekozen.
    p
      | Mocht je toch benieuwd zijn hoe verscheidene sorteeralgoritmes het doen op linked lists, lees dan
      |
      a(href='https://citeseerx.ist.psu.edu/viewdoc/download?doi=10.1.1.83.3116&rep=rep1&type=pdf') A comparative study of linked list sorting algorithms
      | .
  component-section
    div(slot='title')
      a(href='https://ans.app/digital_test/assignments/297670/routing') Keuzeproces Java SE 17 voor sorteeralgoritmes (op Ans)
    component-exercise
  component-section
    div(slot='title') Timsort
    component-section
      div(slot='title') Waarom je Timsort leert
      p Timsort
        a(href='https://devdocs.io/openjdk~17/java.base/java/util/arrays#sort(T[],java.util.Comparator)') wordt gebruikt in onder andere de standaardbibliotheek van CPython en Java
        | .
      component-section
        div(slot='title') Principes
        p Timsort is een samengesteld (hybride), adaptief, stabiel sorteeralgoritme.
          | Hybride, want het combineert mergen (geïnspireerd door Merge sort) met Insertion sort.
          | Als er deelrijen van minder dan grofweg 32 lang ontstaan, wordt Insertion sort toegepast.
          | Een dergelijke optimalisatie is echter ook gangbaar bij andere complexe sorteeralgoritmes, zoals Quicksort.
          | Timsort is bovendien ook ten aanzien van de inhoud van de invoerdata adaptief, doordat het al gesorteerde deelrijen herkent in de invoerdata, en de tijd minimaliseert die het aan die deelrijen besteedt met ‘galloping’.
          | Timsort heeft een looptijd van \(O(n \log n)\) in het slechtste geval, maar is in het beste geval lineair.
          | Alleen bij primitieve rijen die nauwelijks voorgesorteerd zijn is een geoptimaliseerde Quicksort in de praktijk sneller, omdat Quicksort profiteert van gunstige interactie met CPU-architectuur (caching, etc.).
          | Timsort gebruikt in het slechtste echter lineair (zoals Merge sort) in plaats van logaritmisch (zoals Quicksort) ruimte.
        p Doordat Timsort erg nieuw is vergeleken met de klassieke sorteeralgoritmes (2002) en in de praktijk is bedacht in plaats van in de academische wereld, is er helaas weinig educatieve documentatie over.
          | De auteur Tim Peters heeft voor CPython een complete uitleg geschreven, die handig is als je Timsort zelf implementeert:
          p.bron
            a(href='https://svn.python.org/projects/python/trunk/Objects/listsort.txt')
              code listsort.txt
        p De volgende blogpost is beknopter:
        p.bron
          a(href='https://realpython.com/sorting-algorithms-python/#the-timsort-algorithm-in-python') The Timsort Algorithm in Python
        p Het volgende wetenschappelijke artikel is ter verdieping.
          | Lees alleen de achtergronden en de pseudocode, dus sla de wiskundige stukjes over.
        p.bron.extra
          a(href='https://drops.dagstuhl.de/opus/volltexte/2018/9467/pdf/LIPIcs-ESA-2018-4.pdf') On the Worst-Case Complexity of TimSort
  component-section
    div(slot='title') Radix sort
    component-section
      div(slot='title') Waarom je Radix sort leert
      p Tot nog toe hebben we met vergelijkingsgebaseerde sorteeralgoritmes gewerkt.
      // TODO: support
      | Er is geen vergelijkingsgebaseerd algoritme mogelijk dat in het slechtste geval een lagere looptijdgroei heeft dan linearitmisch.
      | Als je niet hele itemwaardes vergelijkt maar de cijfers op posities, dan kan je sneller de volgorde bepalen.
      | Bijvoorbeeld: 123, 16 en 130 zijn getallen met drie posities (16 is dan 016).
      p.praktijk Radix sort wordt toegepast voor het snel sorteren van grote datasets gebaseerd op primitieve types.
        | Radix sort werkt goed voor bijvoorbeeld het sorteren van data waar weinig variatie in zit maar grote aantallen, zoals kentekens.
        | Ook is Radix sort
        |
        a(href='https://cs.stackexchange.com/a/12228') praktisch voor parallel sorteren
        | .
    component-section
      div(slot='title') Principes
    p De
      |
      em.term radix
      |
      | van een getal is de basis waarmee je telt.
      | Decimale getallen hebben een radix \(R\) van 10 (de
      |
      em.term cijfers (digits)
      |
      | 0 tot en met 9 zijn mogelijk), terwijl binaire getallen een radix van 2 hebben (cijfers 0 en 1).
    p Radix sort heeft in alle gevallen een looptijd van \(Θ(nw)\), waarbij \(n\) het aantal items is, en \(w\) de woordlengte.
      | Radix sort heeft een lineaire looptijd ten opzichte van het aantal items \(n\).
      | Radix sort heeft in de praktijk alleen een korte looptijd als je vooraf een deelbereik weet van mogelijke itemwaardes uit het bereik van alle theoretisch mogelijke waardes (bijvoorbeeld, getallen \([1, 1000]\) van een unsigned integer), en het deelbereik relatief klein is.
    p Het is mogelijk om zowel strings als getallen te sorteren met Radix sort.
      | In principe kan je alle data sorteren, zolang deze maar als een rij getallen (desnoods bits) is uit te drukken.
      | Bij primitieve datatypes is dat niet altijd mogelijk met dezelfde logica voor alle groottes: zo staat de meest significante bit van een signed getal voor het teken negatief of positief.
      | Bij datastructuren moet je precies weten waar elk veld begint en wat het type ervan is, als je de datastructuur als een rij bytes uitleest.
      | Bij een string zijn de indexen mogelijke posities en de karakters mogelijke waarden op die posities.
      | De cijfermogelijkheden worden ook vaak het
      |
      em.term alfabet
      |
      | genoemd.
      | Ook een getal is voor Radix sort als een ‘string’ (rij letters) te beschouwen.
    p Er zijn globaal twee varianten van Radix sort:
    ul
      li
        p
          em.term Most significant digit (MSD)
          | .
          | Hierbij werkt het algoritme van links naar rechts: het meest signifcante positie eerst.
          | Bijvoorbeeld 1 bij 123.
          | Terwijl Quicksort twee- of driewegs partitioneert, partitioneert een MSD radix sort \(R\)-wegs.
          | Werkt het beste op strings van variabele lengtes.
      li
        p
        em.term Least significant digit (LSD)
        | .
        | Andersom.
        | Meestal geïmplementeerd voor stabiel sorteren.
        | Werkte het beste op korte strings van vaste lengtes.
    p.bron
      a(href='https://opendsa-server.cs.vt.edu/OpenDSA/Books/Everything/html/RadixSort.html') Radix Sort
    p.bron Linear Time Sorting: Counting Sort, Radix Sort, and Bucket Sort
    component-video(videoid='pJ1IQD5rv4o', title='Linear Time Sorting: Counting Sort, Radix Sort, and Bucket Sort')
    | Dit hoofdstuk uit Algorithms in Java van Robert Sedgewick is verdiepend:
    p.bron.extra
      a(href='https://www.cs.princeton.edu/courses/archive/spr09/cos226/handouts/Algs3Ch10.pdf') Radix Sorting
